package ac.hiu.kt.testdb;

import org.springframework.context.support.*;
import java.util.*;
import java.io.*;

public class TestSampleBookJdbcDao {
  public static void main(String args[]) throws IOException {
    ClassPathXmlApplicationContext ctx;
    ctx = new ClassPathXmlApplicationContext
                             ("./sampleBookJdbcDaoContext.xml");
    SampleBookJdbcDaoImple sampleBookDao = 
         (SampleBookJdbcDaoImple)ctx.getBean("sampleBookDao");
    BufferedReader br = new BufferedReader(
                          new InputStreamReader(System.in));
    while(true) {
      System.out.print("find,findall,insert,update,delete,exit:");
      String command=br.readLine();
      if (command.equals("find")) {
        System.out.print("Book Id:");
        String id = br.readLine();
        List results = sampleBookDao.findBook(id);
        System.out.println("number of Results:"+results.size());
        for (int i=0; i<results.size();i++) {
          Book bk = (Book)results.get(i);
          System.out.println("id:"+bk.getId()+" name:"+bk.getName());
        }
      } else if (command.equals("findall")) {
        List results = sampleBookDao.findBook();
        System.out.println("number of Results:"+results.size());
        for (int i=0; i<results.size();i++) {
          Book bk = (Book)results.get(i);
          System.out.println("id:"+bk.getId()+" name:"+bk.getName());
        }
      } else if (command.equals("insert")) {
        System.out.print("Book Id:");
        String id = br.readLine();
        System.out.print("Book Name:");
        String name = br.readLine();
        System.out.println("return:"+
                                sampleBookDao.insertBook(id, name));
      } else if (command.equals("update")) {
        System.out.print("Book Id:");
        String id = br.readLine();
        System.out.print("Book Name:");
        String name = br.readLine();
        System.out.println("return:"+
                                sampleBookDao.updateBook(id, name));
      } else if (command.equals("delete")) {
        System.out.print("Book Id:");
        String id = br.readLine();
        System.out.println("return:"+sampleBookDao.deleteBook(id));
      } else if (command.equals("exit")) {
        break;
      }
    }
  }
}
