// BookInfopDAO̎iSpringJdbcۃt[[NARDBMSIy[VNX𗘗pj
package ac.hiu.kt.tosho.dao;

import java.sql.*;
import java.util.*;
import javax.sql.*;
import org.springframework.jdbc.core.*;
import org.springframework.jdbc.core.support.*;
import org.springframework.jdbc.object.*;
import ac.hiu.kt.tosho.model.*;

public class BookInfoJdbcDaoImple extends JdbcDaoSupport implements BookInfoDao {
  private FindBookStatusQuery findBookStatusQuery = null;
  private UpdateBookStatusSql updateBookStatusSql = null;
  private FindBookInfoQuery findBookInfoQuery = null;
  private FindBookPositionQuery findBookPositionQuery = null;

  // JdbcDaoSupporNXŁAɌĂяo
  protected void initDao() {
    // dataSourceSpring̒`t@CŐݒ肳
    findBookStatusQuery = new FindBookStatusQuery(getDataSource());
    updateBookStatusSql = new UpdateBookStatusSql(getDataSource());
    findBookInfoQuery = new FindBookInfoQuery(getDataSource());
    findBookPositionQuery = new FindBookPositionQuery(getDataSource());
  }
    
  // statusXVp\bh
  public void updateBookStatus(String bookId, String status) {
    String[] param = {status, bookId};
    updateBookStatusSql.update(param);
  }

  // statusƉp\bh
  public String findBookStatus(String bookId) {
    List results = findBookStatusQuery.execute(bookId);
    if (results.size()!=1) {
      return "none";
    }
    String status = (String)results.get(0);
      return status;
    }

  public Book findBookInfo(String bookId) {
    List results = findBookInfoQuery.execute(bookId);
    if (results.size()!=1) {
      return null;
    }
    return (Book)results.get(0); 
  }

  public BookPosition findBookPosition(String bookId) {
    List results = findBookPositionQuery.execute(bookId);
    if (results.size()!=1) {
      return null;
    }
    return (BookPosition)results.get(0); 
  }

  // BookstatusƉp̃T|[gNX
  private static class FindBookStatusQuery extends MappingSqlQuery {
    private static final String SQL_QUERY
        = "select status from Book where id=?;";

    public FindBookStatusQuery(DataSource ds) {
      super(ds,SQL_QUERY);
      super.declareParameter(new SqlParameter("id", Types.VARCHAR));
      compile();
    }

    public Object mapRow(ResultSet rs, int rowNumber) throws SQLException {
      String status = rs.getString("status");
      return status;
    }
  }

  // BookstatusXVp̃T|[gNX
  private static class UpdateBookStatusSql extends SqlUpdate {
    private static final String SQL_QUERY
        = "update Book set status=? where id=?;";

    public UpdateBookStatusSql(DataSource ds) {
      super(ds, SQL_QUERY);
      super.declareParameter(new SqlParameter("status", Types.VARCHAR));
      super.declareParameter(new SqlParameter("id", Types.VARCHAR));
      compile();
    }
  }

  // Book̏Ɖp̃T|[gNX
  private static class FindBookInfoQuery extends MappingSqlQuery {
    private static final String SQL_QUERY
        = "select book.id, bookSpec.title, bookSpec.bookCode "+
          "from bookSpec, book " + 
          "where book.id=? and book.bookSpecId=bookSpec.id;";

    public FindBookInfoQuery(DataSource ds) {
      super(ds,SQL_QUERY);
      super.declareParameter(new SqlParameter("id", Types.VARCHAR));
      compile();
    }

    public Object mapRow(ResultSet rs, int rowNumber) throws SQLException {
      String id = rs.getString("book.id");
      String title = rs.getString("bookSpec.title");
      String bookCode = rs.getString("bookSpec.bookCode");
      Book book=new Book(id,title,bookCode);
      return book;
    }
  }

    // BookPosition̏Ɖp̃T|[gNX
  private static class FindBookPositionQuery extends MappingSqlQuery {
    private static final String SQL_QUERY
        = "select shelfNumber, rowNumber from book where id=?;";

    public FindBookPositionQuery(DataSource ds) {
      super(ds,SQL_QUERY);
      super.declareParameter(new SqlParameter("id", Types.VARCHAR));
      compile();
    }

    public Object mapRow(ResultSet rs, int rowNumber) throws SQLException {
      int shelfNo=rs.getInt("shelfNumber");
      int rowNo=rs.getInt("rowNumber");
      BookPosition position=new BookPosition(shelfNo, rowNo);
      return position;
    }
  }
}
