package ac.hiu.kt.tosho.dao;

import java.sql.*;
import java.util.*;
import javax.sql.*;
import org.springframework.jdbc.core.*;
import org.springframework.jdbc.core.support.*;
import org.springframework.jdbc.object.*;
import ac.hiu.kt.tosho.model.*;

public class RentInfoJdbcDaoImple extends JdbcDaoSupport implements RentInfoDao {
  private DeleteRentDetailSql deleteRentalDetailSql = null;
  private FindRentInfoDetailQuery findRentInfoDetailQuery = null;
  
  protected void initDao() {
    deleteRentalDetailSql = new DeleteRentDetailSql(getDataSource());
    findRentInfoDetailQuery = new FindRentInfoDetailQuery(getDataSource());
  }
  public void deleteRentDetail(String bookId) {
    deleteRentalDetailSql.update(bookId);
  }

  public RentInfoDetail findRentInfoDetail(String bookId) {
    List results = findRentInfoDetailQuery.execute(bookId);
    if (results.size()!=1) {
      return null;
    }
    return (RentInfoDetail)results.get(0); 
  }

  // rentInfoDetail폜p̃T|[gNX
  private static class DeleteRentDetailSql extends SqlUpdate {
    private static final String SQL_QUERY
            = "delete from rentInfoDetail where bookId=?;";

    public DeleteRentDetailSql(DataSource ds) {
      super(ds, SQL_QUERY);
      super.declareParameter(new SqlParameter("bookId", Types.VARCHAR));
      compile();
    }
  }
  //RentInfoDetail̏Ɖp̃T|[gNX
  private static class FindRentInfoDetailQuery extends MappingSqlQuery {
    private static final String SQL_QUERY
        = "select rentInfo.userId, rentInfoDetail.bookId "+
          "from rentInfo, rentInfoDetail " + 
          "where rentInfoDetail.bookId=? and " +
          "rentInfoDetail.rentInfoId=rentInfo.id;";

    public FindRentInfoDetailQuery(DataSource ds) {
      super(ds,SQL_QUERY);
      super.declareParameter(new SqlParameter("bookId", Types.VARCHAR));
      compile();
    }

    public Object mapRow(ResultSet rs, int rowNumber) throws SQLException {
      String userId = rs.getString("rentInfo.userId");
      String bookId = rs.getString("rentInfoDetail.bookId");
      RentInfoDetail detail=new RentInfoDetail(userId, bookId);
      return detail;
    }
  }
}
