// BookInfopDAO̎iSpringJdbcۃt[[NARDBMSIy[VNX𗘗pj
package ac.hiu.kt.dao;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.List;

import javax.sql.DataSource;

import org.springframework.jdbc.core.SqlParameter;
import org.springframework.jdbc.core.support.JdbcDaoSupport;
import org.springframework.jdbc.object.MappingSqlQuery;
import org.springframework.jdbc.object.SqlUpdate;

public class BookInfoJdbcDaoImple extends JdbcDaoSupport implements BookInfoDao {
    private FindBookStatusQuery findBookStatusQuery = null;
    private UpdateBookStatusSql updateBookStatusSql = null;

    // JdbcDaoSupporNXŁAɌĂяo
    protected void initDao() {
      // dataSourceSpring̒`t@CŐݒ肳
      findBookStatusQuery = new FindBookStatusQuery(getDataSource());
      updateBookStatusSql = new UpdateBookStatusSql(getDataSource());
    }
    
    // statusXVp\bh
    public void updateBookStatus(String bookId, String status) {
      String[] param = {status, bookId};
      updateBookStatusSql.update(param);
    }

    // statusƉp\bh
    public String findBookStatus(String bookId) {
      List results = findBookStatusQuery.execute(bookId);
      if (results.size()!=1) {
        return "none";
      }
      String status = (String)results.get(0);
      return status;
    }

    // BookstatusƉp̃T|[gNX
    private static class FindBookStatusQuery extends MappingSqlQuery {
      private static final String SQL_QUERY
        = "select status from Book where id=?;";

      public FindBookStatusQuery(DataSource ds) {
        super(ds,SQL_QUERY);
        super.declareParameter(new SqlParameter("id", Types.VARCHAR));
        compile();
      }

      public Object mapRow(ResultSet rs, int rowNumber) throws SQLException {
        String status = rs.getString("status");
        return status;
      }
    }

    // BookstatusXVp̃T|[gNX
    private static class UpdateBookStatusSql extends SqlUpdate {
      private static final String SQL_QUERY
        = "update Book set status=? where id=?;";

      public UpdateBookStatusSql(DataSource ds) {
        super(ds, SQL_QUERY);
        super.declareParameter(new SqlParameter("status", Types.VARCHAR));
        super.declareParameter(new SqlParameter("id", Types.VARCHAR));
        compile();
      }
    }
}
