import ac.hiu.kt.dao.*;
import java.sql.Connection;
import javax.sql.DataSource;
import org.dbunit.DatabaseTestCase;
import org.dbunit.database.DatabaseConnection;
import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.xml.FlatXmlDataSet;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class BookInfoDaoStatusTest extends DatabaseTestCase {
    // Springp̒`t@C
    private static final String CONTEXT_FILE = "./daoContext.xml";            // I
    // dbUnitp̃eXgf[^`t@C
    private static final String TESTDATA_FILE = "./testdataBookStatus.xml";   // I
    // CONTEXT_FILEŎw肵DataSourceBean
    private static final String DATASOURCE = "dataSource";                    // I
    // CONTEXT_FILEŎw肵DAO Bean̖O
    private static final String DAO_BEAN = "bookInfoDao";
    
    // tB[h
    private ClassPathXmlApplicationContext ctx;

    // eXgOɎs郁\bhI[o[Ch
    protected void setUp() throws Exception {                                 // D
        ctx = new ClassPathXmlApplicationContext(CONTEXT_FILE);               // E
        super.setUp();  // X[p[NX̃\bhĂяo                 // F
    }

    // eXgɎs郁\bhI[o[Chi͉Ȃj
    protected void tearDown() throws Exception {                              // G
        super.tearDown();  // Xp[NX̃\bhĂяo                // H
    }
    
    // DataBaseTestCaseabstract\bh`
    //   DatabaseConnectioñCX^Xm点
    protected IDatabaseConnection getConnection() throws Exception {          // @
        DataSource dataSource = (DataSource)ctx.getBean(DATASOURCE);          // A
        Connection conn = dataSource.getConnection();                         // A
        return new DatabaseConnection(conn);
    }

    //   eXgf[^pDataset̃CX^Xm点
    protected IDataSet getDataSet() throws Exception {                        // B
        return new FlatXmlDataSet(                                            // C
                           getClass().getResourceAsStream(TESTDATA_FILE));    // C
    }

    // eXg
    public void testUpdateBookStatus() throws Exception {
        String status;
        // DAOBeanSpring`t@C瓾
        BookInfoDao bookInfoDao = (BookInfoDao)ctx.getBean(DAO_BEAN);         // J
        // O
        status = bookInfoDao.findBookStatus("039911174");                     // K
        assertEquals("rented",status);                                        // K
        // f[^x[XANZX
        bookInfoDao.updateBookStatus("039911174","rentable");                 // L
        // 
        status = bookInfoDao.findBookStatus("039911174");                     // M
        assertEquals("rentable",status);                                      // M
    }
}
