package ac.hiu.kt.bgame.model;

import java.util.*;
import ac.hiu.kt.bgame.dao.*;

public class InputResultHandlerImple implements InputResultHandler {
  private TaikaiDao taikaiDao;
  private TeamDao teamDao; 
  private GameDao gameDao;
  
  public void setTaikaiDao(TaikaiDao dao) {this.taikaiDao=dao;}
  public void setTeamDao(TeamDao dao) {this.teamDao=dao;}
  public void setGameDao(GameDao dao) {this.gameDao=dao; }

  public List getTaikais() {
    return taikaiDao.findTaikai();
  }

  public List getTeams(int taikaiId) {
    List teams=teamDao.findTeam(taikaiId);
    return teams;
  }

  public boolean addResult(int taikaiId, Game result) {
    int team1No=result.getTeam1No();
    int team2No=result.getTeam2No();
    int team1Point=result.getTeam1Point();
    int team2Point=result.getTeam2Point();
    Game game=gameDao.findGameByTeamNo(taikaiId, team1No, team2No);
    if (game==null) {
      game=gameDao.findGameByTeamNo(taikaiId, team2No, team1No);
      if (game!=null) {
        result.setTeam1No(team2No);
        result.setTeam2No(team1No);
        result.setTeam1Point(team2Point);
        result.setTeam2Point(team1Point);
      }
    }
    if (game==null) {
      // System.out.println("null");
      // return true;
      return gameDao.insertGame(taikaiId, result); 
    } else {
      // System.out.println("not null");
      // return true;
      return gameDao.updateGame(taikaiId, result);
    }
  }
}
