package ac.hiu.kt.bgame.jsf;

import java.io.*;
import java.util.*;
import javax.faces.context.*;
import javax.faces.el.*;
import javax.faces.model.*;
import ac.hiu.kt.bgame.model.*;

public class InputResultManagedBean implements Serializable {
  private static final long serialVersionUID = 1L;
  private String selectedId;
  private List taikaiItems;
  private int taikaiId;
  private String taikaiName;
  private List teamItems;
  private int team1No;
  private int team2No;
  private int team1Point;
  private int team2Point;
  private String message;
  
  public InputResultManagedBean() {
    taikaiItems = new ArrayList();
    taikaiId=-1;
    taikaiName="";
    selectedId="";
    teamItems = new ArrayList();
  }

  public void setSelectedId(String id) {
    this.selectedId=id;
  }
  public String getSelectedId() { return this.selectedId; }
 
  public List getTaikaiItems() {
    taikaiItems.clear();
    List taikais=this.getHandler().getTaikais();
    for (int i=0;i<taikais.size();i++) {
      Taikai taikai=(Taikai)taikais.get(i);
      System.out.println(taikai.getId()+" "+taikai.getName());
      taikaiItems.add(new SelectItem(""+taikai.getId(),taikai.getName()));   
    }
    return this.taikaiItems;
  }

  public int getTaikaiId() { return this.taikaiId; }
  public String getTaikaiName() {return this.taikaiName; }
  
  public String selectTaikai() {
    taikaiId = Integer.parseInt(selectedId);
    List taikais=this.getHandler().getTaikais();
    for (int i=0;i<taikais.size();i++) {
      Taikai taikai=(Taikai)(taikais.get(i));
      if (taikaiId==taikai.getId()) {
        taikaiName=taikai.getName();
        break;
      }
    }
    System.out.println("id:"+taikaiId+" name:"+taikaiName);
    return "";
  }

  public List getTeamItems() {
    teamItems.clear();
    List teams=this.getHandler().getTeams(taikaiId);
    System.out.println("taikaiId:"+taikaiId+"n:"+teams.size());
    for (int i=0;i<teams.size();i++) {
      Team team=(Team)teams.get(i);
      teamItems.add(new SelectItem(""+team.getNo(),team.getName()));
    }
    return this.teamItems;
  }

  public void setTeamItems(List teamItems) {
    this.teamItems=teamItems;
  }
  public void setTeam1No(int no) { this.team1No=no; }
  public int getTeam1No() { return this.team1No; }
  public void setTeam1Point(int point) { this.team1Point=point; }
  public int getTeam1Point() { return this.team1Point; }
  public void setTeam2No(int no) { this.team2No=no; }
  public int getTeam2No() { return this.team2No; }
  public void setTeam2Point(int point) { this.team2Point=point; }
  public int getTeam2Point() { return this.team2Point; }

  public String inputResult() {
    Game game=new Game(team1No, team2No, "", "");
    game.setPoints(team1Point, team2Point);
    boolean ok=this.getHandler().addResult(taikaiId, game);
    if (ok) {
      message="_𐳏ɓo^܂";
      return "success";
    } else {
      message="_o^Ɏs܂";
      return "ng";
    }
  }
  
  public String getMessage() { return this.message; }
  
  private InputResultHandler getHandler() {
    // SpringHandler擾
    FacesContext context = FacesContext.getCurrentInstance();
    VariableResolver vr = context.getApplication().getVariableResolver();
    InputResultHandler inputResultHandler = 
                     (InputResultHandler)vr.resolveVariable(context, "inputResultHandler");
    return inputResultHandler;
  }
}
