package ac.hiu.kt.bgame.jsf;

import java.io.*;
import java.util.*;
import javax.faces.context.*;
import javax.faces.el.*;
import javax.faces.model.*;
import ac.hiu.kt.bgame.model.*;

public class ShowResultManagedBean implements Serializable {
  private static final long serialVersionUID = 1L;
  private String selectedId;
  private List taikaiItems;
  private int taikaiId;
  private String taikaiName;
  private String[] messages;

  public ShowResultManagedBean() {
    taikaiItems=new ArrayList();
    selectedId="";
    taikaiId=-1;
    taikaiName="";
  }
  
  public void setSelectedId(String id) {
    this.selectedId=id;
  }
  public String getSelectedId() { return this.selectedId; }
 
  public List getTaikaiItems() {
    taikaiItems.clear();
    List taikais=this.getHandler().getTaikais();
    //if (taikais==null) {
    //  System.out.println("taikais is null");
    //} else {
    //  System.out.println("n:"+taikais.size());
    //}
    for (int i=0;i<taikais.size();i++) {
      Taikai taikai=(Taikai)taikais.get(i);
      System.out.println(taikai.getId()+" "+taikai.getName());
      taikaiItems.add(new SelectItem(""+taikai.getId(),taikai.getName()));   
    }
    return this.taikaiItems;
  }
  public int getTaikaiId() { return this.taikaiId; }
  public String getTaikaiName() {return this.taikaiName; }
  
  public String selectTaikai() {
    taikaiId = Integer.parseInt(selectedId);
    List taikais=this.getHandler().getTaikais();
    for (int i=0;i<taikais.size();i++) {
      Taikai taikai=(Taikai)(taikais.get(i));
      if (taikaiId==taikai.getId()) {
        taikaiName=taikai.getName();
        break;
      }
    }
    System.out.println("id:"+taikaiId+" name:"+taikaiName);
    List games=getHandler().getResults(taikaiId);
    if (games.size()==0) {
      messages=new String[1];
      messages[0]=taikaiName+"̎ʂ͂܂";
    } else {
      messages=new String[games.size()];
      for (int i=0; i<games.size();i++) {
        Game game=(Game)games.get(i);
        messages[i]=game.getTeam1Name()+" "+game.getTeam1Point() +" - "+
                    game.getTeam2Point()+" "+game.getTeam2Name();
      }
    }
    for (int i=0;i<messages.length;i++){
      System.out.println(messages[i]);
    }
    return ""; 
  }

  public String[] getMessages() { return this.messages; }

  private ShowResultHandler getHandler() {
    // SpringHandler擾
    FacesContext context = FacesContext.getCurrentInstance();
    VariableResolver vr = context.getApplication().getVariableResolver();
    ShowResultHandler showResultHandler = 
                     (ShowResultHandler)vr.resolveVariable(context, "showResultHandler");
    return showResultHandler;
  }
}
