package ac.hiu.kt.bgame.dao;

import java.sql.*;
import java.util.*;
import javax.sql.*;
import org.springframework.jdbc.core.*;
import org.springframework.jdbc.core.support.*;
import org.springframework.jdbc.object.*;
import ac.hiu.kt.bgame.model.*;

public class TaikaiJdbcDaoImple extends JdbcDaoSupport
                               implements TaikaiDao {
  private FindTaikaiQuery findTaikaiQuery=null;
  private FindTaikaiQueryByName findTaikaiQueryByName = null;
  private InsertTaikaiSql insertTaikaiSql = null;
  
  protected void initDao() {
    findTaikaiQuery = new FindTaikaiQuery(getDataSource());
    findTaikaiQueryByName = new FindTaikaiQueryByName(getDataSource());
    insertTaikaiSql = new InsertTaikaiSql(getDataSource());
  }

  public List findTaikai() {
    return findTaikaiQuery.execute();
  }
  
  public Taikai findTaikai(String taikaiName) {
    String[] params = {taikaiName} ;
    List results=findTaikaiQueryByName.execute(params);
    if (results.size()!=1) {
      return null;
    } else {
      return (Taikai)results.get(0);
    }
  }
  
  public boolean insertTaikai(String name) {
    String[] params = {name} ;
    int n = insertTaikaiSql.update(params);
    if (n!=1) {
      return false;
    } else {
      return true;
    }
  }

  // ׂĂ̑wvNX
  private class FindTaikaiQuery extends MappingSqlQuery {
    private static final String SQL_QUERY =
        "select id, name from taikai;";
    public FindTaikaiQuery(DataSource ds) {
      super(ds, SQL_QUERY);
      compile();
    }
    
    public Object mapRow(ResultSet rs, int row) throws SQLException {
      int id=rs.getInt("id");
      String name=rs.getString("name");
      Taikai taikai=new Taikai(id, name);
      return taikai;
    }
  }

  // ̑wvNX
  private class FindTaikaiQueryByName extends MappingSqlQuery {
    private static final String SQL_QUERY =
        "select id, name from taikai where name=?;";
    public FindTaikaiQueryByName(DataSource ds) {
      super(ds, SQL_QUERY);
      super.declareParameter(new SqlParameter("name", Types.VARCHAR));
      compile();
    }
    
    public Object mapRow(ResultSet rs, int row) throws SQLException {
      int id=rs.getInt("id");
      String name=rs.getString("name");
      Taikai taikai=new Taikai(id, name);
      return taikai;
    }
  }
  
  // o^pwvNX
  private class InsertTaikaiSql extends SqlUpdate {
    private static final String SQL_INSERT =
        "insert into taikai (name) values(?);";
    public InsertTaikaiSql(DataSource ds) {
      super(ds, SQL_INSERT);
      super.declareParameter(new SqlParameter("name", Types.VARCHAR));
      compile();
    }
  }
}
