import java.sql.*;
import java.util.*;
import javax.sql.*;
import org.dbunit.*;
import org.dbunit.database.*;
import org.dbunit.dataset.*;
import org.dbunit.dataset.xml.*;
import org.springframework.context.support.*;
import ac.hiu.kt.bgame.dao.*;
import ac.hiu.kt.bgame.model.*;

public class TestTaikaiDao extends DatabaseTestCase {
  // Springp̒`t@C
  protected static final String CONTEXT_FILE = "./applicationContext.xml";
  // CONTEXT_FILEŎw肵DataSourceBean
  protected static final String DATASOURCE = "dataSource";
  // dbUnitp̃eXgf[^`t@C
  protected static String TESTDATAFILE="./testdata.xml";
    
  protected ClassPathXmlApplicationContext ctx;

  // eXgOɎs郁\bhI[o[Ch  
  protected void setUp() throws Exception {
    ctx = new ClassPathXmlApplicationContext(CONTEXT_FILE); 
    super.setUp();  // X[p[NX̃\bhĂяo
  }

  // eXgɎs郁\bhI[o[Chi͉Ȃj
  protected void tearDown() throws Exception {
    super.tearDown();  // Xp[NX̃\bhĂяo
  }
        
  // DataBaseTestCaseabstract\bh`
  //   DatabaseConnectioñCX^Xm点
  protected IDatabaseConnection getConnection() throws Exception {
    DataSource dataSource = (DataSource)ctx.getBean(DATASOURCE);
    Connection conn = dataSource.getConnection();
    return new DatabaseConnection(conn);
  }

  //   eXgf[^pDataset̃CX^Xm点
  protected IDataSet getDataSet() throws Exception {
      return new FlatXmlDataSet(
                         getClass().getResourceAsStream(TESTDATAFILE));
  }
  
  // findTaikai\bhiȂjeXg
  public void testFindTaikai1() throws Exception {
    Taikai taikai;
    List results;
      
    // DAOBeanSpring`t@C瓾
    TaikaiDao taikaiDao = (TaikaiDao)ctx.getBean("taikaiDao");
    // Oif[^ZbgŐݒj
    // f[^x[XANZX
    results=taikaiDao.findTaikai();
    // 
    assertEquals(2,results.size());
    taikai=(Taikai)results.get(0);
    assertEquals(1,taikai.getId());
    assertEquals("2005Nx2tG[O",taikai.getName());
    taikai=(Taikai)results.get(1);
    assertEquals(2,taikai.getId());
    assertEquals("2005Nx1tG[O",taikai.getName());
  }

  // findTaikai\bhijeXg(1)
  public void testFindTaikai2() throws Exception {
    Taikai taikai;
      
    // DAOBeanSpring`t@C瓾
    TaikaiDao taikaiDao = (TaikaiDao)ctx.getBean("taikaiDao");
    // Oif[^ZbgŐݒj
    // f[^x[XANZX
    taikai=taikaiDao.findTaikai("2005Nx2tG[O");
    // 
    assertEquals(1,taikai.getId());
  }

  // findTaikai\bhijeXg(2)
  public void testFindTaikai3() throws Exception {
    Taikai taikai;
      
    // DAOBeanSpring`t@C瓾
    TaikaiDao taikaiDao = (TaikaiDao)ctx.getBean("taikaiDao");
    // Oif[^ZbgŐݒj
    // f[^x[XANZX
    taikai=taikaiDao.findTaikai("2005Nx1tG[O");
    // 
    assertEquals(2,taikai.getId());
  }

  // insertTaikai\bh
  public void testInsertTaikai() throws Exception {
    String name="2005Nx3tG[O";
    Taikai taikai;
    boolean ok;
      
    // DAOBeanSpring`t@C瓾
    TaikaiDao taikaiDao = (TaikaiDao)ctx.getBean("taikaiDao");
    // OiȎo^ĂȂƁj
    taikai=taikaiDao.findTaikai(name);
    assertNull(taikai);
    // f[^x[XANZX
    ok=taikaiDao.insertTaikai(name);
    // 
    assertEquals(ok,true);
    taikai=taikaiDao.findTaikai(name);
    assertNotNull(taikai);
    // id ͎XV͂
    assertEquals(3,taikai.getId());
    assertEquals(name,taikai.getName());
  }
}
